####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package Search;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
use Parse::Yapp::Driver;

#line 1 "Search.yp"


#
# Copyright (C) Motorola 2003 - All rights reserved
# Copyright (C) Crawford Currie 2004
# Copyright (C) Thomas Weigert 2005
#

# TODO: quote parsing does not allow embedded escaped quotes
# TODO: make Search::mbrf consistent with bracket parsing
# TODO: allow unqouted numbers in numeric operations
# TODO: do embedded matches make sense e.g., [? $owner =~ [? $house='fred ] ]
# TODO: EARLIER_THAN, LATER_THAN, WITHIN_DAYS not supported by lexer or matches
# TODO: Search::toString should not put quotes around unquoted things

# To generate the parser use
#    yapp -v Search.yp
#

=begin text

---++ class Search
Search operators work on the fields of a TWiki::Contrib::DBCacheContrib::Map. The fields are given by name, and the values by strings. Strings should always be surrounded by 'single-quotes'. String which are regular expressions use 'perl' re syntax (see =man perlre= for help)

*Warning* single and double quotes are not allowed in values!

The following operators are available:

| *Operator* | *LHS* | *RHS* | *Meaning* |
| <code>=</code> | field name | regular expression | Value exactly matches this regular expression. The expression must match the whole string. |
| <code>!=</code> | field name | regular expression | Field is not this RE. Inverse of = |
| <code>=~</code> | field name | regular expression | Value contains this regular expression i.e. the RE is found somewhere in the field value. |
| <code>&lt;</code> | field name | integer (string containing an integer e.g '4') | Number is < |
| <code>&gt;</code> | field name | integer | Number is > |
| <code>&gt;=</code> | field name | integer | Number is >= |
| <code>&lt;=</code> | field name | integer | Number is <= |
| <code>!</code> | none | expr | Boolean NOT |
| <code>AND</code> | expr | expr | Boolean AND |
| <code>OR</code> | expr | expr | Boolean OR |
| <code>()</code> | N/A | N/A | Bracketed subexpression |

A search object implements the "matches" method as its general
contract with the rest of the world.

---+++ Example
Get a list of hidden attachments:
<verbatim>
  $db = new TWiki::Contrib::DBCacheContrib::DBCache( $web ); # always done
  $db->load();
  my $search = create Search("attr = 'h'");

  foreach my $topic ($db->getKeys()) {
     my $attachments = $topic->get("attachments");
     foreach my $val ($attachments->getValues()) {
       if ($search->matches($val)) {
          print $val->get("name") . "\n";
       }
     }
  }
</verbatim>

=cut


use TWiki::Plugins::SpreadSheetPlugin::Calc;
use TWiki::Func;

=begin text

---+++ =create($string)=
   * =$string= - string containing an expression to parse
Construct a new search node by parsing the passed expression.

=cut

  sub create {
    my ( $class, $string, $left, $op, $right, $evalright ) = @_;
    if ( defined( $string )) {
      if ( $string =~ m/^\s*$/o ) {
	return create Search( undef, undef, "TRUE", undef );
      } else {
	my $calc = new Search;
	$calc->YYData->{INPUT} = $string;
	return $calc->YYParse(yylex => \&Lexer);
      }
    } else {
      my $this;
      $this = bless( {}, $class );
      $this->{right} = $right;
      $this->{eval} = $evalright;
      $this->{left} = $left;
      $this->{op} = $op;
      return $this;
    }
  }





sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'' => -1,
			'MATCH' => 1,
			'CALC' => 3,
			"(" => 5,
			"!" => 6,
			'error' => 7,
			'PRIM' => 9
		},
		GOTOS => {
			'exp' => 2,
			'input' => 4,
			'TERM' => 8,
			'line' => 10
		}
	},
	{#State 1
		DEFAULT => -24
	},
	{#State 2
		ACTIONS => {
			"AND" => 11,
			"OR" => 12
		},
		DEFAULT => -3
	},
	{#State 3
		ACTIONS => {
			'' => -22,
			"AND" => -22,
			"OR" => -22,
			")" => -22
		},
		DEFAULT => -6
	},
	{#State 4
		ACTIONS => {
			'' => 13
		}
	},
	{#State 5
		ACTIONS => {
			'MATCH' => 1,
			"!" => 6,
			"(" => 5,
			'CALC' => 3,
			'PRIM' => 9
		},
		GOTOS => {
			'exp' => 14,
			'TERM' => 8
		}
	},
	{#State 6
		ACTIONS => {
			'MATCH' => 1,
			"!" => 6,
			"(" => 5,
			'CALC' => 3,
			'PRIM' => 9
		},
		GOTOS => {
			'exp' => 15,
			'TERM' => 8
		}
	},
	{#State 7
		DEFAULT => -4
	},
	{#State 8
		ACTIONS => {
			"!=" => 16,
			"<" => 17,
			"=~" => 18,
			"<=" => 21,
			">" => 22,
			"=" => 20,
			">=" => 19
		}
	},
	{#State 9
		ACTIONS => {
			'' => -21,
			"AND" => -21,
			"OR" => -21,
			")" => -21
		},
		DEFAULT => -5
	},
	{#State 10
		DEFAULT => -2
	},
	{#State 11
		ACTIONS => {
			'MATCH' => 1,
			"!" => 6,
			"(" => 5,
			'CALC' => 3,
			'PRIM' => 9
		},
		GOTOS => {
			'exp' => 23,
			'TERM' => 8
		}
	},
	{#State 12
		ACTIONS => {
			'MATCH' => 1,
			"!" => 6,
			"(" => 5,
			'CALC' => 3,
			'PRIM' => 9
		},
		GOTOS => {
			'exp' => 24,
			'TERM' => 8
		}
	},
	{#State 13
		DEFAULT => 0
	},
	{#State 14
		ACTIONS => {
			"AND" => 11,
			"OR" => 12,
			")" => 25
		}
	},
	{#State 15
		DEFAULT => -23
	},
	{#State 16
		ACTIONS => {
			'QUOT' => 27,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 28
		}
	},
	{#State 17
		ACTIONS => {
			'QUOT' => 30,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 31
		}
	},
	{#State 18
		ACTIONS => {
			'QUOT' => 32,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 33
		}
	},
	{#State 19
		ACTIONS => {
			'QUOT' => 34,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 35
		}
	},
	{#State 20
		ACTIONS => {
			'QUOT' => 36,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 37
		}
	},
	{#State 21
		ACTIONS => {
			'QUOT' => 38,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 39
		}
	},
	{#State 22
		ACTIONS => {
			'QUOT' => 40,
			'CALC' => 26,
			'PRIM' => 29
		},
		GOTOS => {
			'TERM' => 41
		}
	},
	{#State 23
		DEFAULT => -25
	},
	{#State 24
		ACTIONS => {
			"AND" => 11
		},
		DEFAULT => -26
	},
	{#State 25
		DEFAULT => -27
	},
	{#State 26
		DEFAULT => -6
	},
	{#State 27
		DEFAULT => -9
	},
	{#State 28
		DEFAULT => -12
	},
	{#State 29
		DEFAULT => -5
	},
	{#State 30
		DEFAULT => -15
	},
	{#State 31
		DEFAULT => -19
	},
	{#State 32
		DEFAULT => -8
	},
	{#State 33
		DEFAULT => -11
	},
	{#State 34
		DEFAULT => -13
	},
	{#State 35
		DEFAULT => -17
	},
	{#State 36
		DEFAULT => -7
	},
	{#State 37
		DEFAULT => -10
	},
	{#State 38
		DEFAULT => -14
	},
	{#State 39
		DEFAULT => -18
	},
	{#State 40
		DEFAULT => -16
	},
	{#State 41
		DEFAULT => -20
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'input', 0, undef
	],
	[#Rule 2
		 'input', 1,
sub
#line 108 "Search.yp"
{ $_[1] }
	],
	[#Rule 3
		 'line', 1,
sub
#line 112 "Search.yp"
{ ++$_[0]->YYData->{LINE}; $_[1] }
	],
	[#Rule 4
		 'line', 1,
sub
#line 113 "Search.yp"
{ ++$_[0]->YYData->{LINE}; undef }
	],
	[#Rule 5
		 'TERM', 1,
sub
#line 116 "Search.yp"
{ $_[1] }
	],
	[#Rule 6
		 'TERM', 1,
sub
#line 117 "Search.yp"
{ create Search( undef, undef, 'calc', $_[1], undef ) }
	],
	[#Rule 7
		 'exp', 3,
sub
#line 121 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 8
		 'exp', 3,
sub
#line 122 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 9
		 'exp', 3,
sub
#line 123 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 10
		 'exp', 3,
sub
#line 124 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 11
		 'exp', 3,
sub
#line 125 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 12
		 'exp', 3,
sub
#line 126 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 13
		 'exp', 3,
sub
#line 127 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 14
		 'exp', 3,
sub
#line 128 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 15
		 'exp', 3,
sub
#line 129 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 16
		 'exp', 3,
sub
#line 130 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 17
		 'exp', 3,
sub
#line 131 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 18
		 'exp', 3,
sub
#line 132 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 19
		 'exp', 3,
sub
#line 133 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 20
		 'exp', 3,
sub
#line 134 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3], 1 ) }
	],
	[#Rule 21
		 'exp', 1,
sub
#line 135 "Search.yp"
{ create Search( undef, "text", "=~", $_[1] ) }
	],
	[#Rule 22
		 'exp', 1,
sub
#line 136 "Search.yp"
{ create Search( undef, undef, 'calc', $_[1], undef ) }
	],
	[#Rule 23
		 'exp', 2,
sub
#line 137 "Search.yp"
{ create Search( undef, undef, $_[1], $_[2], undef ) }
	],
	[#Rule 24
		 'exp', 1,
sub
#line 138 "Search.yp"
{ create Search( undef, undef, 'match', $_[1], undef ) }
	],
	[#Rule 25
		 'exp', 3,
sub
#line 139 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 26
		 'exp', 3,
sub
#line 140 "Search.yp"
{ create Search( undef, $_[1], $_[2], $_[3] ) }
	],
	[#Rule 27
		 'exp', 3,
sub
#line 141 "Search.yp"
{ $_[2] }
	]
],
                                  @_);
    bless($self,$class);
}

#line 144 "Search.yp"


sub Error {
    my($parser)=shift;

	push(@{$parser->YYData->{ERRLINES}}, $parser->YYData->{LINE});
}

sub Lexer {
    my($parser)=shift;

        exists($parser->YYData->{LINE})
    or  $parser->YYData->{LINE}=1;

        $parser->YYData->{INPUT}
    or  return('',undef);

    $parser->YYData->{INPUT}=~s/^[ \t]+//;

    for ($parser->YYData->{INPUT}) {
        s/^([0-9]+(?:\.[0-9]+)?)// and return('NUM',$1);
	s/^(\'.*?\')// and return('QUOT',substr($1,1,-1));
	s/^(\=\~)// and return($1,$1);
	s/^(\=)// and return($1,$1);
	s/^(\!\=)// and return($1,$1);
	s/^(\>\=)// and return($1,$1);
	s/^(\>)// and return($1,$1);
	s/^(\<\=)// and return($1,$1);
	s/^(\<)// and return($1,$1);
	s/^(\!)// and return($1,$1);
	s/^(\()// and return($1,$1);
	s/^(\))// and return($1,$1);
	s/^(AND)// and return($1,$1);
	s/^(OR)// and return($1,$1);
	s/^\$CALC\(\"(.*?)\"\)// and return('CALC',$1);
        s/^(\w+\[\?.*?\])// and return('MATCH',$1);
        s/^(\w+(?:(?:\.\w+)|(?:\[[0-9]+\]))*)// and return('PRIM',$1);
    }
}

=begin text

---+++ =matches($object)= -> boolean
   * =$object= - object to test; must implement =get=
See if object matches the search. =$object= can actually be any object that provides
the method "get" that returns a value given a string key.

=cut
  sub matches {
    my ( $this, $map, $case ) = @_;

    my $op = $this->{op};

    return 1 if ( $op eq "TRUE" );

    my $r = $this->{right};
    return 0 unless ( defined( $r ));

    if ($op eq "!") { return !( $r->matches( $map, $case )) };

    if ($op eq "match") { 
      my $subfield = $map->get( $r );
      if ( defined( $subfield )) {
	if ( $subfield->isa( "TWiki::Contrib::DBCacheContrib::Array" ) && ($subfield->size() > 0) ) {
	  return $subfield;
	} else { return 0; }
      } else { return 0; }
    }

    if ($op eq "calc") {
	return _evalCalc($r, $map);
    }

    my $l = $this->{left};
    return 0 unless ( defined( $l ));

    if ( $op eq "OR" ) {  
      my $tmp = $l->matches( $map, $case );
      return $tmp if ($tmp || ! defined $tmp);
      return $r->matches( $map, $case );
    }
    if ( $op eq "AND" ) {
      my $tmp = $l->matches( $map, $case );
      return $tmp if (! $tmp && defined $tmp);
      return $r->matches( $map, $case );
    }

    return 0 unless ( defined( $map ));

    my $val;

    if ( ref($l) eq "Search" && $l->{op} eq "calc" ) {
      $val = _evalCalc($l->{right}, $map);
    } else {
      $val = $map->get( $l );
      # Compatibility: values have now moved down into the form for topics,
      # but we need this just in case the search specifier is "old style"
      unless ($val) {
	$val = $map->get($map->get("form"))->get( $l );
      }
      return 0 unless ( defined( $val ));
    }

    $val = undef unless $val;
    return $val unless ( $r );
    if ( ref($r) eq "Search" && $r->{op} eq "calc" ) {
      $r = _evalCalc($r->{right}, $map);
    } else {
      # expand variables
      $r = $map->get( $r ) if $this->{eval};
    }

    if ( $case ) {
      if ( $op eq "=" )  { return ( $val =~ m/^$r$/ ) };
      if ( $op eq "!=" ) { return ( $val !~ m/^$r$/ ) };
      if ( $op eq "=~" ) { return ( $val =~ m/$r/ ) };
    } else {
      if ( $op eq "=" )  { return ( $val =~ m/^$r$/i ) };
      if ( $op eq "!=" ) { return ( $val !~ m/^$r$/i ) };
      if ( $op eq "=~" ) { return ( $val =~ m/$r/i ) };
    }
    if ( $op eq ">" )  { return ( $val > $r ) };
    if ( $op eq "<" )  { return ( $val < $r ) };
    if ( $op eq ">=" ) { return ( $val >= $r ) };
    if ( $op eq "<=" ) { return ( $val <= $r ) };

    return 0;
  }

  sub _evalCalc {
    my ($calc, $map) = @_;
    # substitute for "$T(\s*xxx\s*)" the value of $map->get("xxx");
    # then evaluate calc
    $calc =~ s/\$T\(\s*(\w+(?:(?:\.\w+)|(?:\[[0-9]+\]))*)\s*\)/$map->get($1)/geos;
    return TWiki::Plugins::SpreadSheetPlugin::Calc::doCalc($calc);
  }

=begin text

---+++ =toString()= -> string
Generates a string representation of the object. Note that quotes will be inserted around any value on the right-hand side.

=cut

  sub toString {
    my $this = shift;

    my $text = "";
    if ( defined( $this->{left} )) {
      if ( !ref($this->{left}) ) {
	$text .= $this->{left}; 
      } else {
	$text .= "(" . $this->{left}->toString() . ")";
      }
      $text .= " ";
    }
    $text .= $this->{op} . " ";
    if ( defined ( $this->{right} )) {
      if ( !ref($this->{right}) ) {
	$text .= "'" . $this->{right} . "'"; 
      } else {
	$text .= "(" . $this->{right}->toString() . ")";
      }
    } else {
      $text = "TRUE";
    }
    return $text;
  }

# PUBLIC but not exported
# bracket-matching split of a string into ( $one, $two ) where $one
# matches the section before the closing bracket and $two matches
# the section after. throws if the closing bracket isn't found.
# Does not allow nested brackets.
sub mbrf {
	my ($ob, $cb, $s) = @_;
	$ob = ord $ob;
	$cb = ord $cb;
	my ( @pre, @post );

	my $state = 0;
	# 1 = in single quoted string
	# 2 = after the closing bracket, collect end of $s
	# Note does not handle escape characters in string

	foreach my $c ( unpack( "C*", $s ) ) {
	   if ( $state == 2 ) { push( @post, $c ); next; }
	   if ( $state == 1 ) {
	      if ( $c == 39 ) { $state = 0; push( @pre, $c ); next };
           }	
	   if ( $c == $cb ) { $state = 2; next };
	   if ( $c == 39 ) { $state = 1; push( @pre, $c ); next };
	   push( @pre, $c );
	}

	return ( pack( "C*", @pre ), pack( "C*", @post ) ) if $state == 2;
	die "ERROR: mismatched $ob$cb at $s";
}

1;
